'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var styled = require('styled-components');
var styled__default = _interopDefault(styled);
var PropTypes = _interopDefault(require('prop-types'));
var React = require('react');
var React__default = _interopDefault(React);
var ReactSelect = _interopDefault(require('react-select'));
var makeAnimated = _interopDefault(require('react-select/lib/animated'));

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var taggedTemplateLiteral = function (strings, raw) {
  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var badge = PropTypes.shape({
  status: colorState,
  title: PropTypes.string,
  position: position
});
var position = PropTypes.oneOf(['topRight', 'topLeft', 'bottomRight', 'bottomLeft', 'topStart', 'topEnd', 'bottomStart', 'bottomEnd']);

var colorState = PropTypes.oneOf(['Info', 'Success', 'Danger', 'Primary', 'Warning', 'Disabled']);

var placement = PropTypes.oneOf(['start', 'end', 'right', 'left', 'top', 'bottom']);

var trigger = PropTypes.oneOf(['click', 'hover', 'focus']);

var statusArray = ['Info', 'Success', 'Danger', 'Primary', 'Warning'];

var size = PropTypes.oneOf(['XXS', 'XS', 'SM', 'MD', 'LG', 'XL', 'XXL']);

var shape = PropTypes.oneOf(['Rectangle', 'SemiRound', 'Round']);

var itemType = {
  title: PropTypes.string.isRequired,
  link: PropTypes.any,
  expanded: PropTypes.bool,
  group: PropTypes.bool,
  hidden: PropTypes.bool,
  icon: PropTypes.string,
  target: PropTypes.string,
  url: PropTypes.string
};

var _templateObject = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2 = taggedTemplateLiteral(['\n      display: flex;\n      min-width: 0%;\n      position: relative;\n      margin-bottom: 1rem;\n      \n      .label {\n        background: ', ';\n        color: ', ';\n        ', '\n        top: 0;\n        transition: transform 150ms cubic-bezier(0.4, 0, 0.2, 1),\n          opacity 150ms cubic-bezier(0.4, 0, 0.2, 1);\n        z-index: 1;\n        transform-origin: top ', ';\n        pointer-events: none;\n        position: absolute;\n        line-height: 1.15;\n        padding: 0 5px;\n        font-size: ', ';\n        transform: translate(\n          ', '', ', \n          calc(', ' + ', ')\n        );\n      }\n\n      input,\n      textarea {\n        &:not([disabled]):focus ~ .label,\n        &[value]:not([value=""]) ~ .label{\n          transform: scale(.90) translate(\n            ', '', ', \n            -50%\n          );\n        }\n        &:not([disabled]):focus ~ .label{\n          color: ', ';\n        }\n        &[value]:not([value=""]) ~ .label{\n          ', ';\n        }\n      }\n\n      input,\n      textarea{\n        background-color: ', ';\n        border-width: ', ';\n        border-color: ', ';\n        border-style: ', ';\n        color: ', ';\n        ', '\n        \n        &:focus {\n          outline: none;\n          background-color: ', ';\n          ', '\n        }\n\n      \n        &[disabled] ~ .label {\n          opacity: 0.5;\n        }\n      \n        ', '\n        ', '\n        ', '\n      }\n    '], ['\n      display: flex;\n      min-width: 0%;\n      position: relative;\n      margin-bottom: 1rem;\n      \n      .label {\n        background: ', ';\n        color: ', ';\n        ', '\n        top: 0;\n        transition: transform 150ms cubic-bezier(0.4, 0, 0.2, 1),\n          opacity 150ms cubic-bezier(0.4, 0, 0.2, 1);\n        z-index: 1;\n        transform-origin: top ', ';\n        pointer-events: none;\n        position: absolute;\n        line-height: 1.15;\n        padding: 0 5px;\n        font-size: ', ';\n        transform: translate(\n          ', '', ', \n          calc(', ' + ', ')\n        );\n      }\n\n      input,\n      textarea {\n        &:not([disabled]):focus ~ .label,\n        &[value]:not([value=""]) ~ .label{\n          transform: scale(.90) translate(\n            ', '', ', \n            -50%\n          );\n        }\n        &:not([disabled]):focus ~ .label{\n          color: ', ';\n        }\n        &[value]:not([value=""]) ~ .label{\n          ', ';\n        }\n      }\n\n      input,\n      textarea{\n        background-color: ', ';\n        border-width: ', ';\n        border-color: ', ';\n        border-style: ', ';\n        color: ', ';\n        ', '\n        \n        &:focus {\n          outline: none;\n          background-color: ', ';\n          ', '\n        }\n\n      \n        &[disabled] ~ .label {\n          opacity: 0.5;\n        }\n      \n        ', '\n        ', '\n        ', '\n      }\n    ']),
    _templateObject3 = taggedTemplateLiteral(['\n            border-color: ', ';\n          '], ['\n            border-color: ', ';\n          ']),
    _templateObject4 = taggedTemplateLiteral(['\n            border-radius: ', ';\n          '], ['\n            border-radius: ', ';\n          ']),
    _templateObject5 = taggedTemplateLiteral(['\n            font-size: ', ';\n            padding: ', ';\n          '], ['\n            font-size: ', ';\n            padding: ', ';\n          ']);

/* eslint-disable indent */
var GroupStyle = styled__default.div(_templateObject, function (_ref) {
  var theme = _ref.theme,
      fieldSize = _ref.fieldSize,
      status = _ref.status,
      shape$$1 = _ref.shape,
      fullWidth = _ref.fullWidth;

  var padding = theme['formControlPadding' + fieldSize].split(' ');
  return styled.css(_templateObject2, theme.formControlBg, theme.formControlPlaceholderColor, theme.dir === 'rtl' ? 'right: 0;' : 'left: 0;', theme.dir === 'rtl' ? 'right' : 'left', theme['formControlFontSize' + fieldSize], theme.dir === 'rtl' && '-', padding[1], padding[0], theme.formControlBorderWidth, theme.dir === 'rtl' && '-', padding[1], status ? theme['formControl' + status + 'BorderColor'] : theme.formControlSelectedBorderColor, status && 'color: ' + theme['formControl' + status + 'BorderColor'], theme.formControlBg, theme.formControlBorderWidth, theme.formControlBorderColor, theme.formControlBorderType, theme.formControlTextPrimaryColor, fullWidth && 'width: 100%;', theme.formControlFocusBg, !status && 'border-color: ' + theme.formControlSelectedBorderColor + ';', status && styled.css(_templateObject3, theme['formControl' + status + 'BorderColor']), shape$$1 && styled.css(_templateObject4, theme['formControl' + shape$$1 + 'BorderRadius']), fieldSize && styled.css(_templateObject5, theme['formControlFontSize' + fieldSize], theme['formControlPadding' + fieldSize]));
});

function InputGroup(props) {
  return React__default.createElement(
    GroupStyle,
    props,
    props.children,
    React__default.createElement(
      'div',
      { className: 'label' },
      props.label
    )
  );
}

InputGroup.defaultProps = {
  fieldSize: 'MD',
  shape: 'Rectangle'
};
InputGroup.propTypes = {
  shape: shape,
  fullWidth: PropTypes.bool,
  fieldSize: PropTypes.oneOf(['SM', 'MD', 'LG']),
  status: PropTypes.oneOf(['Info', 'Warning', 'Success', 'Danger'])
};

function _extends$1() {
  _extends$1 = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends$1.apply(this, arguments);
}

function colorToInt(color) {
  return Math.round(color * 255);
}

function convertToInt(red, green, blue) {
  return colorToInt(red) + "," + colorToInt(green) + "," + colorToInt(blue);
}

function hslToRgb(hue, saturation, lightness, convert) {
  if (convert === void 0) {
    convert = convertToInt;
  }

  if (saturation === 0) {
    // achromatic
    return convert(lightness, lightness, lightness);
  } // formular from https://en.wikipedia.org/wiki/HSL_and_HSV


  var huePrime = hue % 360 / 60;
  var chroma = (1 - Math.abs(2 * lightness - 1)) * saturation;
  var secondComponent = chroma * (1 - Math.abs(huePrime % 2 - 1));
  var red = 0;
  var green = 0;
  var blue = 0;

  if (huePrime >= 0 && huePrime < 1) {
    red = chroma;
    green = secondComponent;
  } else if (huePrime >= 1 && huePrime < 2) {
    red = secondComponent;
    green = chroma;
  } else if (huePrime >= 2 && huePrime < 3) {
    green = chroma;
    blue = secondComponent;
  } else if (huePrime >= 3 && huePrime < 4) {
    green = secondComponent;
    blue = chroma;
  } else if (huePrime >= 4 && huePrime < 5) {
    red = secondComponent;
    blue = chroma;
  } else if (huePrime >= 5 && huePrime < 6) {
    red = chroma;
    blue = secondComponent;
  }

  var lightnessModification = lightness - chroma / 2;
  var finalRed = red + lightnessModification;
  var finalGreen = green + lightnessModification;
  var finalBlue = blue + lightnessModification;
  return convert(finalRed, finalGreen, finalBlue);
}

var namedColorMap = {
  aliceblue: 'f0f8ff',
  antiquewhite: 'faebd7',
  aqua: '00ffff',
  aquamarine: '7fffd4',
  azure: 'f0ffff',
  beige: 'f5f5dc',
  bisque: 'ffe4c4',
  black: '000',
  blanchedalmond: 'ffebcd',
  blue: '0000ff',
  blueviolet: '8a2be2',
  brown: 'a52a2a',
  burlywood: 'deb887',
  cadetblue: '5f9ea0',
  chartreuse: '7fff00',
  chocolate: 'd2691e',
  coral: 'ff7f50',
  cornflowerblue: '6495ed',
  cornsilk: 'fff8dc',
  crimson: 'dc143c',
  cyan: '00ffff',
  darkblue: '00008b',
  darkcyan: '008b8b',
  darkgoldenrod: 'b8860b',
  darkgray: 'a9a9a9',
  darkgreen: '006400',
  darkgrey: 'a9a9a9',
  darkkhaki: 'bdb76b',
  darkmagenta: '8b008b',
  darkolivegreen: '556b2f',
  darkorange: 'ff8c00',
  darkorchid: '9932cc',
  darkred: '8b0000',
  darksalmon: 'e9967a',
  darkseagreen: '8fbc8f',
  darkslateblue: '483d8b',
  darkslategray: '2f4f4f',
  darkslategrey: '2f4f4f',
  darkturquoise: '00ced1',
  darkviolet: '9400d3',
  deeppink: 'ff1493',
  deepskyblue: '00bfff',
  dimgray: '696969',
  dimgrey: '696969',
  dodgerblue: '1e90ff',
  firebrick: 'b22222',
  floralwhite: 'fffaf0',
  forestgreen: '228b22',
  fuchsia: 'ff00ff',
  gainsboro: 'dcdcdc',
  ghostwhite: 'f8f8ff',
  gold: 'ffd700',
  goldenrod: 'daa520',
  gray: '808080',
  green: '008000',
  greenyellow: 'adff2f',
  grey: '808080',
  honeydew: 'f0fff0',
  hotpink: 'ff69b4',
  indianred: 'cd5c5c',
  indigo: '4b0082',
  ivory: 'fffff0',
  khaki: 'f0e68c',
  lavender: 'e6e6fa',
  lavenderblush: 'fff0f5',
  lawngreen: '7cfc00',
  lemonchiffon: 'fffacd',
  lightblue: 'add8e6',
  lightcoral: 'f08080',
  lightcyan: 'e0ffff',
  lightgoldenrodyellow: 'fafad2',
  lightgray: 'd3d3d3',
  lightgreen: '90ee90',
  lightgrey: 'd3d3d3',
  lightpink: 'ffb6c1',
  lightsalmon: 'ffa07a',
  lightseagreen: '20b2aa',
  lightskyblue: '87cefa',
  lightslategray: '789',
  lightslategrey: '789',
  lightsteelblue: 'b0c4de',
  lightyellow: 'ffffe0',
  lime: '0f0',
  limegreen: '32cd32',
  linen: 'faf0e6',
  magenta: 'f0f',
  maroon: '800000',
  mediumaquamarine: '66cdaa',
  mediumblue: '0000cd',
  mediumorchid: 'ba55d3',
  mediumpurple: '9370db',
  mediumseagreen: '3cb371',
  mediumslateblue: '7b68ee',
  mediumspringgreen: '00fa9a',
  mediumturquoise: '48d1cc',
  mediumvioletred: 'c71585',
  midnightblue: '191970',
  mintcream: 'f5fffa',
  mistyrose: 'ffe4e1',
  moccasin: 'ffe4b5',
  navajowhite: 'ffdead',
  navy: '000080',
  oldlace: 'fdf5e6',
  olive: '808000',
  olivedrab: '6b8e23',
  orange: 'ffa500',
  orangered: 'ff4500',
  orchid: 'da70d6',
  palegoldenrod: 'eee8aa',
  palegreen: '98fb98',
  paleturquoise: 'afeeee',
  palevioletred: 'db7093',
  papayawhip: 'ffefd5',
  peachpuff: 'ffdab9',
  peru: 'cd853f',
  pink: 'ffc0cb',
  plum: 'dda0dd',
  powderblue: 'b0e0e6',
  purple: '800080',
  rebeccapurple: '639',
  red: 'f00',
  rosybrown: 'bc8f8f',
  royalblue: '4169e1',
  saddlebrown: '8b4513',
  salmon: 'fa8072',
  sandybrown: 'f4a460',
  seagreen: '2e8b57',
  seashell: 'fff5ee',
  sienna: 'a0522d',
  silver: 'c0c0c0',
  skyblue: '87ceeb',
  slateblue: '6a5acd',
  slategray: '708090',
  slategrey: '708090',
  snow: 'fffafa',
  springgreen: '00ff7f',
  steelblue: '4682b4',
  tan: 'd2b48c',
  teal: '008080',
  thistle: 'd8bfd8',
  tomato: 'ff6347',
  turquoise: '40e0d0',
  violet: 'ee82ee',
  wheat: 'f5deb3',
  white: 'fff',
  whitesmoke: 'f5f5f5',
  yellow: 'ff0',
  yellowgreen: '9acd32'
  /**
   * Checks if a string is a CSS named color and returns its equivalent hex value, otherwise returns the original color.
   * @private
   */

};

function nameToHex(color) {
  if (typeof color !== 'string') return color;
  var normalizedColorName = color.toLowerCase();
  return namedColorMap[normalizedColorName] ? "#" + namedColorMap[normalizedColorName] : color;
}

var hexRegex = /^#[a-fA-F0-9]{6}$/;
var hexRgbaRegex = /^#[a-fA-F0-9]{8}$/;
var reducedHexRegex = /^#[a-fA-F0-9]{3}$/;
var reducedRgbaHexRegex = /^#[a-fA-F0-9]{4}$/;
var rgbRegex = /^rgb\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*\)$/;
var rgbaRegex = /^rgba\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*([-+]?[0-9]*[.]?[0-9]+)\s*\)$/;
var hslRegex = /^hsl\(\s*(\d{0,3}[.]?[0-9]+)\s*,\s*(\d{1,3})%\s*,\s*(\d{1,3})%\s*\)$/;
var hslaRegex = /^hsla\(\s*(\d{0,3}[.]?[0-9]+)\s*,\s*(\d{1,3})%\s*,\s*(\d{1,3})%\s*,\s*([-+]?[0-9]*[.]?[0-9]+)\s*\)$/;
/**
 * Returns an RgbColor or RgbaColor object. This utility function is only useful
 * if want to extract a color component. With the color util `toColorString` you
 * can convert a RgbColor or RgbaColor object back to a string.
 *
 * @example
 * // Assigns `{ red: 255, green: 0, blue: 0 }` to color1
 * const color1 = parseToRgb('rgb(255, 0, 0)');
 * // Assigns `{ red: 92, green: 102, blue: 112, alpha: 0.75 }` to color2
 * const color2 = parseToRgb('hsla(210, 10%, 40%, 0.75)');
 */

function parseToRgb(color) {
  if (typeof color !== 'string') {
    throw new Error('Passed an incorrect argument to a color function, please pass a string representation of a color.');
  }

  var normalizedColor = nameToHex(color);

  if (normalizedColor.match(hexRegex)) {
    return {
      red: parseInt("" + normalizedColor[1] + normalizedColor[2], 16),
      green: parseInt("" + normalizedColor[3] + normalizedColor[4], 16),
      blue: parseInt("" + normalizedColor[5] + normalizedColor[6], 16)
    };
  }

  if (normalizedColor.match(hexRgbaRegex)) {
    var alpha = parseFloat((parseInt("" + normalizedColor[7] + normalizedColor[8], 16) / 255).toFixed(2));
    return {
      red: parseInt("" + normalizedColor[1] + normalizedColor[2], 16),
      green: parseInt("" + normalizedColor[3] + normalizedColor[4], 16),
      blue: parseInt("" + normalizedColor[5] + normalizedColor[6], 16),
      alpha: alpha
    };
  }

  if (normalizedColor.match(reducedHexRegex)) {
    return {
      red: parseInt("" + normalizedColor[1] + normalizedColor[1], 16),
      green: parseInt("" + normalizedColor[2] + normalizedColor[2], 16),
      blue: parseInt("" + normalizedColor[3] + normalizedColor[3], 16)
    };
  }

  if (normalizedColor.match(reducedRgbaHexRegex)) {
    var _alpha = parseFloat((parseInt("" + normalizedColor[4] + normalizedColor[4], 16) / 255).toFixed(2));

    return {
      red: parseInt("" + normalizedColor[1] + normalizedColor[1], 16),
      green: parseInt("" + normalizedColor[2] + normalizedColor[2], 16),
      blue: parseInt("" + normalizedColor[3] + normalizedColor[3], 16),
      alpha: _alpha
    };
  }

  var rgbMatched = rgbRegex.exec(normalizedColor);

  if (rgbMatched) {
    return {
      red: parseInt("" + rgbMatched[1], 10),
      green: parseInt("" + rgbMatched[2], 10),
      blue: parseInt("" + rgbMatched[3], 10)
    };
  }

  var rgbaMatched = rgbaRegex.exec(normalizedColor);

  if (rgbaMatched) {
    return {
      red: parseInt("" + rgbaMatched[1], 10),
      green: parseInt("" + rgbaMatched[2], 10),
      blue: parseInt("" + rgbaMatched[3], 10),
      alpha: parseFloat("" + rgbaMatched[4])
    };
  }

  var hslMatched = hslRegex.exec(normalizedColor);

  if (hslMatched) {
    var hue = parseInt("" + hslMatched[1], 10);
    var saturation = parseInt("" + hslMatched[2], 10) / 100;
    var lightness = parseInt("" + hslMatched[3], 10) / 100;
    var rgbColorString = "rgb(" + hslToRgb(hue, saturation, lightness) + ")";
    var hslRgbMatched = rgbRegex.exec(rgbColorString);

    if (!hslRgbMatched) {
      throw new Error("Couldn't generate valid rgb string from " + normalizedColor + ", it returned " + rgbColorString + ".");
    }

    return {
      red: parseInt("" + hslRgbMatched[1], 10),
      green: parseInt("" + hslRgbMatched[2], 10),
      blue: parseInt("" + hslRgbMatched[3], 10)
    };
  }

  var hslaMatched = hslaRegex.exec(normalizedColor);

  if (hslaMatched) {
    var _hue = parseInt("" + hslaMatched[1], 10);

    var _saturation = parseInt("" + hslaMatched[2], 10) / 100;

    var _lightness = parseInt("" + hslaMatched[3], 10) / 100;

    var _rgbColorString = "rgb(" + hslToRgb(_hue, _saturation, _lightness) + ")";

    var _hslRgbMatched = rgbRegex.exec(_rgbColorString);

    if (!_hslRgbMatched) {
      throw new Error("Couldn't generate valid rgb string from " + normalizedColor + ", it returned " + _rgbColorString + ".");
    }

    return {
      red: parseInt("" + _hslRgbMatched[1], 10),
      green: parseInt("" + _hslRgbMatched[2], 10),
      blue: parseInt("" + _hslRgbMatched[3], 10),
      alpha: parseFloat("" + hslaMatched[4])
    };
  }

  throw new Error("Couldn't parse the color string. Please provide the color as a string in hex, rgb, rgba, hsl or hsla notation.");
}

function rgbToHsl(color) {
  // make sure rgb are contained in a set of [0, 255]
  var red = color.red / 255;
  var green = color.green / 255;
  var blue = color.blue / 255;
  var max = Math.max(red, green, blue);
  var min = Math.min(red, green, blue);
  var lightness = (max + min) / 2;

  if (max === min) {
    // achromatic
    if (color.alpha !== undefined) {
      return {
        hue: 0,
        saturation: 0,
        lightness: lightness,
        alpha: color.alpha
      };
    } else {
      return {
        hue: 0,
        saturation: 0,
        lightness: lightness
      };
    }
  }

  var hue;
  var delta = max - min;
  var saturation = lightness > 0.5 ? delta / (2 - max - min) : delta / (max + min);

  switch (max) {
    case red:
      hue = (green - blue) / delta + (green < blue ? 6 : 0);
      break;

    case green:
      hue = (blue - red) / delta + 2;
      break;

    default:
      // blue case
      hue = (red - green) / delta + 4;
      break;
  }

  hue *= 60;

  if (color.alpha !== undefined) {
    return {
      hue: hue,
      saturation: saturation,
      lightness: lightness,
      alpha: color.alpha
    };
  }

  return {
    hue: hue,
    saturation: saturation,
    lightness: lightness
  };
}

/**
 * Returns an HslColor or HslaColor object. This utility function is only useful
 * if want to extract a color component. With the color util `toColorString` you
 * can convert a HslColor or HslaColor object back to a string.
 *
 * @example
 * // Assigns `{ hue: 0, saturation: 1, lightness: 0.5 }` to color1
 * const color1 = parseToHsl('rgb(255, 0, 0)');
 * // Assigns `{ hue: 128, saturation: 1, lightness: 0.5, alpha: 0.75 }` to color2
 * const color2 = parseToHsl('hsla(128, 100%, 50%, 0.75)');
 */
function parseToHsl(color) {
  // Note: At a later stage we can optimize this function as right now a hsl
  // color would be parsed converted to rgb values and converted back to hsl.
  return rgbToHsl(parseToRgb(color));
}

/**
 * Reduces hex values if possible e.g. #ff8866 to #f86
 * @private
 */
var reduceHexValue = function reduceHexValue(value) {
  if (value.length === 7 && value[1] === value[2] && value[3] === value[4] && value[5] === value[6]) {
    return "#" + value[1] + value[3] + value[5];
  }

  return value;
};

function numberToHex(value) {
  var hex = value.toString(16);
  return hex.length === 1 ? "0" + hex : hex;
}

function colorToHex(color) {
  return numberToHex(Math.round(color * 255));
}

function convertToHex(red, green, blue) {
  return reduceHexValue("#" + colorToHex(red) + colorToHex(green) + colorToHex(blue));
}

function hslToHex(hue, saturation, lightness) {
  return hslToRgb(hue, saturation, lightness, convertToHex);
}

/**
 * Returns a string value for the color. The returned result is the smallest possible hex notation.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: hsl(359, 0.75, 0.4),
 *   background: hsl({ hue: 360, saturation: 0.75, lightness: 0.4 }),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${hsl(359, 0.75, 0.4)};
 *   background: ${hsl({ hue: 360, saturation: 0.75, lightness: 0.4 })};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#b3191c";
 *   background: "#b3191c";
 * }
 */
function hsl(value, saturation, lightness) {
  if (typeof value === 'number' && typeof saturation === 'number' && typeof lightness === 'number') {
    return hslToHex(value, saturation, lightness);
  } else if (typeof value === 'object' && saturation === undefined && lightness === undefined) {
    return hslToHex(value.hue, value.saturation, value.lightness);
  }

  throw new Error('Passed invalid arguments to hsl, please pass multiple numbers e.g. hsl(360, 0.75, 0.4) or an object e.g. rgb({ hue: 255, saturation: 0.4, lightness: 0.75 }).');
}

/**
 * Returns a string value for the color. The returned result is the smallest possible rgba or hex notation.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: hsla(359, 0.75, 0.4, 0.7),
 *   background: hsla({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0,7 }),
 *   background: hsla(359, 0.75, 0.4, 1),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${hsla(359, 0.75, 0.4, 0.7)};
 *   background: ${hsla({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0,7 })};
 *   background: ${hsla(359, 0.75, 0.4, 1)};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "rgba(179,25,28,0.7)";
 *   background: "rgba(179,25,28,0.7)";
 *   background: "#b3191c";
 * }
 */
function hsla(value, saturation, lightness, alpha) {
  if (typeof value === 'number' && typeof saturation === 'number' && typeof lightness === 'number' && typeof alpha === 'number') {
    return alpha >= 1 ? hslToHex(value, saturation, lightness) : "rgba(" + hslToRgb(value, saturation, lightness) + "," + alpha + ")";
  } else if (typeof value === 'object' && saturation === undefined && lightness === undefined && alpha === undefined) {
    return value.alpha >= 1 ? hslToHex(value.hue, value.saturation, value.lightness) : "rgba(" + hslToRgb(value.hue, value.saturation, value.lightness) + "," + value.alpha + ")";
  }

  throw new Error('Passed invalid arguments to hsla, please pass multiple numbers e.g. hsl(360, 0.75, 0.4, 0.7) or an object e.g. rgb({ hue: 255, saturation: 0.4, lightness: 0.75, alpha: 0.7 }).');
}

/**
 * Returns a string value for the color. The returned result is the smallest possible hex notation.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: rgb(255, 205, 100),
 *   background: rgb({ red: 255, green: 205, blue: 100 }),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${rgb(255, 205, 100)};
 *   background: ${rgb({ red: 255, green: 205, blue: 100 })};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#ffcd64";
 *   background: "#ffcd64";
 * }
 */
function rgb(value, green, blue) {
  if (typeof value === 'number' && typeof green === 'number' && typeof blue === 'number') {
    return reduceHexValue("#" + numberToHex(value) + numberToHex(green) + numberToHex(blue));
  } else if (typeof value === 'object' && green === undefined && blue === undefined) {
    return reduceHexValue("#" + numberToHex(value.red) + numberToHex(value.green) + numberToHex(value.blue));
  }

  throw new Error('Passed invalid arguments to rgb, please pass multiple numbers e.g. rgb(255, 205, 100) or an object e.g. rgb({ red: 255, green: 205, blue: 100 }).');
}

/**
 * Returns a string value for the color. The returned result is the smallest possible rgba or hex notation.
 *
 * Can also be used to fade a color by passing a hex value or named CSS color along with an alpha value.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: rgba(255, 205, 100, 0.7),
 *   background: rgba({ red: 255, green: 205, blue: 100, alpha: 0.7 }),
 *   background: rgba(255, 205, 100, 1),
 *   background: rgba('#ffffff', 0.4),
 *   background: rgba('black', 0.7),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${rgba(255, 205, 100, 0.7)};
 *   background: ${rgba({ red: 255, green: 205, blue: 100, alpha: 0.7 })};
 *   background: ${rgba(255, 205, 100, 1)};
 *   background: ${rgba('#ffffff', 0.4)};
 *   background: ${rgba('black', 0.7)};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "rgba(255,205,100,0.7)";
 *   background: "rgba(255,205,100,0.7)";
 *   background: "#ffcd64";
 *   background: "rgba(255,255,255,0.4)";
 *   background: "rgba(0,0,0,0.7)";
 * }
 */
function rgba(firstValue, secondValue, thirdValue, fourthValue) {
  if (typeof firstValue === 'string' && typeof secondValue === 'number') {
    var rgbValue = parseToRgb(firstValue);
    return "rgba(" + rgbValue.red + "," + rgbValue.green + "," + rgbValue.blue + "," + secondValue + ")";
  } else if (typeof firstValue === 'number' && typeof secondValue === 'number' && typeof thirdValue === 'number' && typeof fourthValue === 'number') {
    return fourthValue >= 1 ? rgb(firstValue, secondValue, thirdValue) : "rgba(" + firstValue + "," + secondValue + "," + thirdValue + "," + fourthValue + ")";
  } else if (typeof firstValue === 'object' && secondValue === undefined && thirdValue === undefined && fourthValue === undefined) {
    return firstValue.alpha >= 1 ? rgb(firstValue.red, firstValue.green, firstValue.blue) : "rgba(" + firstValue.red + "," + firstValue.green + "," + firstValue.blue + "," + firstValue.alpha + ")";
  }

  throw new Error('Passed invalid arguments to rgba, please pass multiple numbers e.g. rgb(255, 205, 100, 0.75) or an object e.g. rgb({ red: 255, green: 205, blue: 100, alpha: 0.75 }).');
}

var isRgb = function isRgb(color) {
  return typeof color.red === 'number' && typeof color.green === 'number' && typeof color.blue === 'number' && (typeof color.alpha !== 'number' || typeof color.alpha === 'undefined');
};

var isRgba = function isRgba(color) {
  return typeof color.red === 'number' && typeof color.green === 'number' && typeof color.blue === 'number' && typeof color.alpha === 'number';
};

var isHsl = function isHsl(color) {
  return typeof color.hue === 'number' && typeof color.saturation === 'number' && typeof color.lightness === 'number' && (typeof color.alpha !== 'number' || typeof color.alpha === 'undefined');
};

var isHsla = function isHsla(color) {
  return typeof color.hue === 'number' && typeof color.saturation === 'number' && typeof color.lightness === 'number' && typeof color.alpha === 'number';
};

var errMsg = 'Passed invalid argument to toColorString, please pass a RgbColor, RgbaColor, HslColor or HslaColor object.';
/**
 * Converts a RgbColor, RgbaColor, HslColor or HslaColor object to a color string.
 * This util is useful in case you only know on runtime which color object is
 * used. Otherwise we recommend to rely on `rgb`, `rgba`, `hsl` or `hsla`.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: toColorString({ red: 255, green: 205, blue: 100 }),
 *   background: toColorString({ red: 255, green: 205, blue: 100, alpha: 0.72 }),
 *   background: toColorString({ hue: 240, saturation: 1, lightness: 0.5 }),
 *   background: toColorString({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0.72 }),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${toColorString({ red: 255, green: 205, blue: 100 })};
 *   background: ${toColorString({ red: 255, green: 205, blue: 100, alpha: 0.72 })};
 *   background: ${toColorString({ hue: 240, saturation: 1, lightness: 0.5 })};
 *   background: ${toColorString({ hue: 360, saturation: 0.75, lightness: 0.4, alpha: 0.72 })};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#ffcd64";
 *   background: "rgba(255,205,100,0.72)";
 *   background: "#00f";
 *   background: "rgba(179,25,25,0.72)";
 * }
 */

function toColorString(color) {
  if (typeof color !== 'object') throw new Error(errMsg);
  if (isRgba(color)) return rgba(color);
  if (isRgb(color)) return rgb(color);
  if (isHsla(color)) return hsla(color);
  if (isHsl(color)) return hsl(color);
  throw new Error(errMsg);
}

// Type definitions taken from https://github.com/gcanti/flow-static-land/blob/master/src/Fun.js
// eslint-disable-next-line no-unused-vars
// eslint-disable-next-line no-unused-vars
// eslint-disable-next-line no-redeclare
function curried(f, length, acc) {
  return function fn() {
    // eslint-disable-next-line prefer-rest-params
    var combined = acc.concat(Array.prototype.slice.call(arguments));
    return combined.length >= length ? f.apply(this, combined) : curried(f, length, combined);
  };
} // eslint-disable-next-line no-redeclare


function curry(f) {
  // eslint-disable-line no-redeclare
  return curried(f, f.length, []);
}

/**
 * Changes the hue of the color. Hue is a number between 0 to 360. The first
 * argument for adjustHue is the amount of degrees the color is rotated along
 * the color wheel.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: adjustHue(180, '#448'),
 *   background: adjustHue('180', 'rgba(101,100,205,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${adjustHue(180, '#448')};
 *   background: ${adjustHue('180', 'rgba(101,100,205,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#888844";
 *   background: "rgba(136,136,68,0.7)";
 * }
 */

function adjustHue(degree, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$1({}, hslColor, {
    hue: (hslColor.hue + parseFloat(degree)) % 360
  }));
} // prettier-ignore


var curriedAdjustHue =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(adjustHue);

function guard(lowerBoundary, upperBoundary, value) {
  return Math.max(lowerBoundary, Math.min(upperBoundary, value));
}

/**
 * Returns a string value for the darkened color.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: darken(0.2, '#FFCD64'),
 *   background: darken('0.2', 'rgba(255,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${darken(0.2, '#FFCD64')};
 *   background: ${darken('0.2', 'rgba(255,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#ffbd31";
 *   background: "rgba(255,189,49,0.7)";
 * }
 */

function darken(amount, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$1({}, hslColor, {
    lightness: guard(0, 1, hslColor.lightness - parseFloat(amount))
  }));
} // prettier-ignore


var curriedDarken =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(darken);

/**
 * Decreases the intensity of a color. Its range is between 0 to 1. The first
 * argument of the desaturate function is the amount by how much the color
 * intensity should be decreased.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: desaturate(0.2, '#CCCD64'),
 *   background: desaturate('0.2', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${desaturate(0.2, '#CCCD64')};
 *   background: ${desaturate('0.2', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#b8b979";
 *   background: "rgba(184,185,121,0.7)";
 * }
 */

function desaturate(amount, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$1({}, hslColor, {
    saturation: guard(0, 1, hslColor.saturation - parseFloat(amount))
  }));
} // prettier-ignore


var curriedDesaturate =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(desaturate);

/**
 * Returns a string value for the lightened color.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: lighten(0.2, '#CCCD64'),
 *   background: lighten('0.2', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${lighten(0.2, '#FFCD64')};
 *   background: ${lighten('0.2', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#e5e6b1";
 *   background: "rgba(229,230,177,0.7)";
 * }
 */

function lighten(amount, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$1({}, hslColor, {
    lightness: guard(0, 1, hslColor.lightness + parseFloat(amount))
  }));
} // prettier-ignore


var curriedLighten =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(lighten);

/**
 * Mixes the two provided colors together by calculating the average of each of the RGB components weighted to the first color by the provided weight.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: mix(0.5, '#f00', '#00f')
 *   background: mix(0.25, '#f00', '#00f')
 *   background: mix('0.5', 'rgba(255, 0, 0, 0.5)', '#00f')
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${mix(0.5, '#f00', '#00f')};
 *   background: ${mix(0.25, '#f00', '#00f')};
 *   background: ${mix('0.5', 'rgba(255, 0, 0, 0.5)', '#00f')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#7f007f";
 *   background: "#3f00bf";
 *   background: "rgba(63, 0, 191, 0.75)";
 * }
 */

function mix(weight, color, otherColor) {
  var parsedColor1 = parseToRgb(color);

  var color1 = _extends$1({}, parsedColor1, {
    alpha: typeof parsedColor1.alpha === 'number' ? parsedColor1.alpha : 1
  });

  var parsedColor2 = parseToRgb(otherColor);

  var color2 = _extends$1({}, parsedColor2, {
    alpha: typeof parsedColor2.alpha === 'number' ? parsedColor2.alpha : 1 // The formular is copied from the original Sass implementation:
    // http://sass-lang.com/documentation/Sass/Script/Functions.html#mix-instance_method

  });

  var alphaDelta = color1.alpha - color2.alpha;
  var x = parseFloat(weight) * 2 - 1;
  var y = x * alphaDelta === -1 ? x : x + alphaDelta;
  var z = 1 + x * alphaDelta;
  var weight1 = (y / z + 1) / 2.0;
  var weight2 = 1 - weight1;
  var mixedColor = {
    red: Math.floor(color1.red * weight1 + color2.red * weight2),
    green: Math.floor(color1.green * weight1 + color2.green * weight2),
    blue: Math.floor(color1.blue * weight1 + color2.blue * weight2),
    alpha: color1.alpha + (color2.alpha - color1.alpha) * (parseFloat(weight) / 1.0)
  };
  return rgba(mixedColor);
} // prettier-ignore


var curriedMix =
/*#__PURE__*/
curry
/* ::<number | string, string, string, string> */
(mix);

/**
 * Increases the opacity of a color. Its range for the amount is between 0 to 1.
 *
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: opacify(0.1, 'rgba(255, 255, 255, 0.9)');
 *   background: opacify(0.2, 'hsla(0, 0%, 100%, 0.5)'),
 *   background: opacify('0.5', 'rgba(255, 0, 0, 0.2)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${opacify(0.1, 'rgba(255, 255, 255, 0.9)')};
 *   background: ${opacify(0.2, 'hsla(0, 0%, 100%, 0.5)')},
 *   background: ${opacify('0.5', 'rgba(255, 0, 0, 0.2)')},
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#fff";
 *   background: "rgba(255,255,255,0.7)";
 *   background: "rgba(255,0,0,0.7)";
 * }
 */

function opacify(amount, color) {
  var parsedColor = parseToRgb(color);
  var alpha = typeof parsedColor.alpha === 'number' ? parsedColor.alpha : 1;

  var colorWithAlpha = _extends$1({}, parsedColor, {
    alpha: guard(0, 1, (alpha * 100 + parseFloat(amount) * 100) / 100)
  });

  return rgba(colorWithAlpha);
} // prettier-ignore


var curriedOpacify =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(opacify);

/**
 * Increases the intensity of a color. Its range is between 0 to 1. The first
 * argument of the saturate function is the amount by how much the color
 * intensity should be increased.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: saturate(0.2, '#CCCD64'),
 *   background: saturate('0.2', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${saturate(0.2, '#FFCD64')};
 *   background: ${saturate('0.2', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#e0e250";
 *   background: "rgba(224,226,80,0.7)";
 * }
 */

function saturate(amount, color) {
  var hslColor = parseToHsl(color);
  return toColorString(_extends$1({}, hslColor, {
    saturation: guard(0, 1, hslColor.saturation + parseFloat(amount))
  }));
} // prettier-ignore


var curriedSaturate =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(saturate);

/**
 * Sets the hue of a color to the provided value. The hue range can be
 * from 0 and 359.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: setHue(42, '#CCCD64'),
 *   background: setHue('244', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${setHue(42, '#CCCD64')};
 *   background: ${setHue('244', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#cdae64";
 *   background: "rgba(107,100,205,0.7)";
 * }
 */

function setHue(hue, color) {
  return toColorString(_extends$1({}, parseToHsl(color), {
    hue: parseFloat(hue)
  }));
} // prettier-ignore


var curriedSetHue =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(setHue);

/**
 * Sets the lightness of a color to the provided value. The lightness range can be
 * from 0 and 1.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: setLightness(0.2, '#CCCD64'),
 *   background: setLightness('0.75', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${setLightness(0.2, '#CCCD64')};
 *   background: ${setLightness('0.75', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#4d4d19";
 *   background: "rgba(223,224,159,0.7)";
 * }
 */

function setLightness(lightness, color) {
  return toColorString(_extends$1({}, parseToHsl(color), {
    lightness: parseFloat(lightness)
  }));
} // prettier-ignore


var curriedSetLightness =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(setLightness);

/**
 * Sets the saturation of a color to the provided value. The lightness range can be
 * from 0 and 1.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: setSaturation(0.2, '#CCCD64'),
 *   background: setSaturation('0.75', 'rgba(204,205,100,0.7)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${setSaturation(0.2, '#CCCD64')};
 *   background: ${setSaturation('0.75', 'rgba(204,205,100,0.7)')};
 * `
 *
 * // CSS in JS Output
 * element {
 *   background: "#adad84";
 *   background: "rgba(228,229,76,0.7)";
 * }
 */

function setSaturation(saturation, color) {
  return toColorString(_extends$1({}, parseToHsl(color), {
    saturation: parseFloat(saturation)
  }));
} // prettier-ignore


var curriedSetSaturation =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(setSaturation);

/**
 * Shades a color by mixing it with black. `shade` can produce
 * hue shifts, where as `darken` manipulates the luminance channel and therefore
 * doesn't produce hue shifts.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: shade(0.25, '#00f')
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${shade(0.25, '#00f')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#00003f";
 * }
 */

function shade(percentage, color) {
  return curriedMix(parseFloat(percentage), 'rgb(0, 0, 0)', color);
} // prettier-ignore


var curriedShade =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(shade);

/**
 * Tints a color by mixing it with white. `tint` can produce
 * hue shifts, where as `lighten` manipulates the luminance channel and therefore
 * doesn't produce hue shifts.
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: tint(0.25, '#00f')
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${tint(0.25, '#00f')};
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "#bfbfff";
 * }
 */

function tint(percentage, color) {
  return curriedMix(parseFloat(percentage), 'rgb(255, 255, 255)', color);
} // prettier-ignore


var curriedTint =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(tint);

/**
 * Decreases the opacity of a color. Its range for the amount is between 0 to 1.
 *
 *
 * @example
 * // Styles as object usage
 * const styles = {
 *   background: transparentize(0.1, '#fff');
 *   background: transparentize(0.2, 'hsl(0, 0%, 100%)'),
 *   background: transparentize('0.5', 'rgba(255, 0, 0, 0.8)'),
 * }
 *
 * // styled-components usage
 * const div = styled.div`
 *   background: ${transparentize(0.1, '#fff')};
 *   background: ${transparentize(0.2, 'hsl(0, 0%, 100%)')},
 *   background: ${transparentize('0.5', 'rgba(255, 0, 0, 0.8)')},
 * `
 *
 * // CSS in JS Output
 *
 * element {
 *   background: "rgba(255,255,255,0.9)";
 *   background: "rgba(255,255,255,0.8)";
 *   background: "rgba(255,0,0,0.3)";
 * }
 */

function transparentize(amount, color) {
  var parsedColor = parseToRgb(color);
  var alpha = typeof parsedColor.alpha === 'number' ? parsedColor.alpha : 1;

  var colorWithAlpha = _extends$1({}, parsedColor, {
    alpha: guard(0, 1, (alpha * 100 - parseFloat(amount) * 100) / 100)
  });

  return rgba(colorWithAlpha);
} // prettier-ignore


var curriedTransparentize =
/*#__PURE__*/
curry
/* ::<number | string, string, string> */
(transparentize);

var _templateObject$2 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$1 = taggedTemplateLiteral(['\n    position: relative;\n    display: inline-flex;\n    margin: 0;\n    min-height: inherit;\n    padding: 0.375rem 1.5rem 0.375rem 0;\n\n    input {\n      position: absolute;\n      opacity: 0;\n      &:disabled {\n        & ~ .indicator,\n        & ~ .description {\n          opacity: 0.5;\n        }\n      }\n    }\n    .indicator {\n      border-radius: 0.25rem;\n      flex-shrink: 0;\n      ', '\n    }\n    .description {\n      color: ', ';\n      padding-', ': 0.5rem;\n    }\n    ', '\n  '], ['\n    position: relative;\n    display: inline-flex;\n    margin: 0;\n    min-height: inherit;\n    padding: 0.375rem 1.5rem 0.375rem 0;\n\n    input {\n      position: absolute;\n      opacity: 0;\n      &:disabled {\n        & ~ .indicator,\n        & ~ .description {\n          opacity: 0.5;\n        }\n      }\n    }\n    .indicator {\n      border-radius: 0.25rem;\n      flex-shrink: 0;\n      ', '\n    }\n    .description {\n      color: ', ';\n      padding-', ': 0.5rem;\n    }\n    ', '\n  ']),
    _templateObject3$1 = taggedTemplateLiteral(['\n        &:hover .indicator,\n        input:focus + .indicator {\n          border-color: ', ';\n        }\n      '], ['\n        &:hover .indicator,\n        input:focus + .indicator {\n          border-color: ', ';\n        }\n      ']),
    _templateObject4$1 = taggedTemplateLiteral(['\n    background-color: ', ';\n    width: ', ';\n    height: ', ';\n    border: ', ' solid ', ';\n    &::before {\n      content: \'\';\n      border-style: solid;\n      display: block;\n      margin: 0 auto;\n      transform: rotate(45deg);\n      height: calc(', ' * 0.6);\n      width: calc(', ' * 0.4);\n      border-color: ', ';\n      border-width: 0 ', ' ', ' 0;\n    }\n  '], ['\n    background-color: ', ';\n    width: ', ';\n    height: ', ';\n    border: ', ' solid ', ';\n    &::before {\n      content: \'\';\n      border-style: solid;\n      display: block;\n      margin: 0 auto;\n      transform: rotate(45deg);\n      height: calc(', ' * 0.6);\n      width: calc(', ' * 0.4);\n      border-color: ', ';\n      border-width: 0 ', ' ', ' 0;\n    }\n  ']);

var CheckboxStyle = styled__default.label(_templateObject$2, function (_ref) {
  var theme = _ref.theme,
      checked = _ref.checked,
      disabled = _ref.disabled,
      status = _ref.status;
  return styled.css(_templateObject2$1, indicatorStyle(theme, checked, disabled, status), theme.colorFgHeading, theme.dir === 'rtl' ? 'right' : 'left', !disabled && styled.css(_templateObject3$1, curriedLighten(0.1, theme[hoverBorder(status)])));
});
var hoverBorder = function hoverBorder(status) {
  return status ? 'color' + status : 'checkboxCheckedBorderColor';
};

var indicatorStyle = function indicatorStyle(theme, checked, disabled, status) {
  var state = disabled ? 'Disabled' : checked ? 'Checked' : '';
  var size = theme['checkbox' + state + 'Size'];
  var borderSize = theme['checkbox' + state + 'BorderSize'];
  var checkmark = disabled && checked ? 'Disabled' : checked ? 'Checked' : '';

  var borderColor$$1 = theme['checkbox' + state + 'BorderColor'];
  if (disabled) {
    borderColor$$1 = theme['checkboxBorderColor'];
  }
  if (disabled && checked) {
    borderColor$$1 = theme['checkboxCheckedBorderColor'];
  }
  if (status && checked) {
    borderColor$$1 = theme['color' + status];
  }

  return styled.css(_templateObject4$1, theme['checkbox' + state + 'Bg'], size, size, borderSize, borderColor$$1, size, size, theme['checkbox' + checkmark + 'Checkmark'], borderSize, borderSize);
};

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

var Checkbox = function Checkbox(props) {
  var _useState = React.useState(props.checked ? props.checked : false),
      _useState2 = slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var onChangeHandler = function onChangeHandler() {
    typeof props.onChange === 'function' && props.onChange(!value);
    setValue(!value);
  };

  return React__default.createElement(
    CheckboxStyle,
    {
      disabled: props.disabled,
      checked: value,
      status: props.status,
      className: props.className
    },
    React__default.createElement('input', {
      type: 'checkbox',
      disabled: props.disabled,
      checked: value,
      onChange: onChangeHandler,
      onBlur: props.onBlur
    }),
    React__default.createElement('span', { className: 'indicator' }),
    React__default.createElement(
      'span',
      { className: 'description' },
      props.children
    )
  );
};

Checkbox.propTypes = {
  onChange: PropTypes.func.isRequired,
  onBlur: PropTypes.func,
  checked: PropTypes.bool,
  disabled: PropTypes.bool,
  status: colorState
};

var _templateObject$3 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$2 = taggedTemplateLiteral(['\n    position: relative;\n    .label {\n        background: ', ';\n        ', '\n        top: 0;\n        transition: transform 150ms cubic-bezier(0.4, 0, 0.2, 1),\n          opacity 150ms cubic-bezier(0.4, 0, 0.2, 1);\n        z-index: 1;\n        transform-origin: top ', ';\n        pointer-events: none;\n        position: absolute;\n        line-height: 1.15;\n        padding: 0 5px;\n        font-size: ', ';\n        transform: scale(.90) translate(\n            ', '', ', \n            -50%\n          );\n\n        color: ', ';\n        ', ';\n        ', ';\n      }\n    .select-container {\n      display: flex;\n      min-width: 0%;\n      margin-bottom: 1rem;\n      line-height: 1.15;\n\n      .select__control {\n        background-color: ', ';\n        border-width: ', ';\n        border-color: ', ';\n        border-style: ', ';\n        color: ', ';\n        box-shadow: none;\n        ', '\n        height: calc(\n          (', ' * 2 ) + \n          (', ' * 1.15) +\n          (', ' * 2)\n          );\n\n        ', '\n        ', '\n        .select__value-container {\n          .select__placeholder{\n            color: ', ';\n          }\n          .select__single-value{\n            color: inherit;\n          }\n          .select__multi-value__remove{\n            color: ', ';\n          }\n            \n        }\n      }\n      .select__control--is-focused {\n        outline: none;\n        background-color: ', ';\n        ', '\n      }\n      .select__menu {\n        z-index: 2;\n        box-shadow: none;\n        background-color: ', ';\n        max-height: ', ';\n        border-width: ', ';\n        border-color: ', ';\n        border-style: ', ';\n        .select__option--is-focused,\n        .select__option--is-selected {\n          background-color: ', ';\n          color: ', ';\n        }\n        ', '\n      }\n    }\n  '], ['\n    position: relative;\n    .label {\n        background: ', ';\n        ', '\n        top: 0;\n        transition: transform 150ms cubic-bezier(0.4, 0, 0.2, 1),\n          opacity 150ms cubic-bezier(0.4, 0, 0.2, 1);\n        z-index: 1;\n        transform-origin: top ', ';\n        pointer-events: none;\n        position: absolute;\n        line-height: 1.15;\n        padding: 0 5px;\n        font-size: ', ';\n        transform: scale(.90) translate(\n            ', '', ', \n            -50%\n          );\n\n        color: ', ';\n        ', ';\n        ', ';\n      }\n    .select-container {\n      display: flex;\n      min-width: 0%;\n      margin-bottom: 1rem;\n      line-height: 1.15;\n\n      .select__control {\n        background-color: ', ';\n        border-width: ', ';\n        border-color: ', ';\n        border-style: ', ';\n        color: ', ';\n        box-shadow: none;\n        ', '\n        height: calc(\n          (', ' * 2 ) + \n          (', ' * 1.15) +\n          (', ' * 2)\n          );\n\n        ', '\n        ', '\n        .select__value-container {\n          .select__placeholder{\n            color: ', ';\n          }\n          .select__single-value{\n            color: inherit;\n          }\n          .select__multi-value__remove{\n            color: ', ';\n          }\n            \n        }\n      }\n      .select__control--is-focused {\n        outline: none;\n        background-color: ', ';\n        ', '\n      }\n      .select__menu {\n        z-index: 2;\n        box-shadow: none;\n        background-color: ', ';\n        max-height: ', ';\n        border-width: ', ';\n        border-color: ', ';\n        border-style: ', ';\n        .select__option--is-focused,\n        .select__option--is-selected {\n          background-color: ', ';\n          color: ', ';\n        }\n        ', '\n      }\n    }\n  ']),
    _templateObject3$2 = taggedTemplateLiteral(['\n            border-color: ', ';\n          '], ['\n            border-color: ', ';\n          ']),
    _templateObject4$2 = taggedTemplateLiteral(['\n            border-radius: ', ';\n          '], ['\n            border-radius: ', ';\n          ']),
    _templateObject5$1 = taggedTemplateLiteral(['\n            border: ', ' solid ', ';\n            .select__option--is-focused,\n            .select__option--is-selected {\n              background-color: ', ';\n              color: ', ';\n            }\n          '], ['\n            border: ', ' solid ', ';\n            .select__option--is-focused,\n            .select__option--is-selected {\n              background-color: ', ';\n              color: ', ';\n            }\n          ']);

var StyledSelect = styled__default.div(_templateObject$3, function (_ref) {
  var theme = _ref.theme,
      shape = _ref.shape,
      fieldSize = _ref.fieldSize,
      fullWidth = _ref.fullWidth,
      status = _ref.status,
      focused = _ref.focused;

  var padding = theme['formControlPadding' + fieldSize].split(' ');
  return styled.css(_templateObject2$2, theme.formControlBg, theme.dir === 'rtl' ? 'right: 0;' : 'left: 0;', theme.dir === 'rtl' ? 'right' : 'left', theme['formControlFontSize' + fieldSize], theme.dir === 'rtl' && '-', padding[1], theme.formControlPlaceholderColor, focused && 'color: ' + theme.formControlSelectedBorderColor, status && 'color: ' + theme['formControl' + status + 'BorderColor'], theme.formControlBg, theme.formControlBorderWidth, theme.formControlBorderColor, theme.formControlBorderType, theme.formControlTextPrimaryColor, fullWidth && 'width: 100%;', padding[0], theme['formControlFontSize' + fieldSize], theme.formControlBorderWidth, status && styled.css(_templateObject3$2, theme['formControl' + status + 'BorderColor']), shape && styled.css(_templateObject4$2, theme['formControl' + shape + 'BorderRadius']), theme.formControlPlaceholderColor, theme.colorDanger, theme.formControlFocusBg, !status && 'border-color: ' + theme.formControlSelectedBorderColor + ';', theme.selectBg, theme.selectMaxHeight, theme.formControlBorderWidth, theme.formControlBorderColor, theme.formControlBorderType, theme['colorSuccess'], theme.colorWhite, status && styled.css(_templateObject5$1, theme.selectBorderWidth, theme['color' + status], theme['color' + status], theme.colorWhite));
});

/*
 * @license
 * Copyright OAH Technology. All Rights Reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 */

function Select(props) {
  var _useState = React.useState(false),
      _useState2 = slicedToArray(_useState, 2),
      focused = _useState2[0],
      setFocused = _useState2[1];

  return React__default.createElement(
    StyledSelect,
    _extends({
      focused: focused
    }, props, {
      onClick: function onClick() {
        return setFocused(true);
      },
      onBlur: function onBlur() {
        return setFocused(false);
      }
    }),
    React__default.createElement(
      'div',
      { className: 'label' },
      props.label
    ),
    React__default.createElement(ReactSelect, _extends({
      placeholder: props.label,
      components: makeAnimated()
    }, props, {
      className: 'select-container',
      classNamePrefix: 'select'
    }))
  );
}
Select.defaultProps = {
  fieldSize: 'MD',
  shape: 'Rectangle'
};

Select.propTypes = {
  fullWidth: PropTypes.bool,
  fieldSize: PropTypes.oneOf(['SM', 'MD', 'LG']),
  shape: shape,
  status: PropTypes.oneOf([].concat(toConsumableArray(statusArray)))
};

var _templateObject$4 = taggedTemplateLiteral(['\n  ', '\n'], ['\n  ', '\n']),
    _templateObject2$3 = taggedTemplateLiteral(['\n      position: relative;\n      display: inline-flex;\n      margin: 0;\n      min-height: inherit;\n      padding: 0.375rem 1.5rem 0.375rem 0;\n      input {\n        position: absolute;\n        opacity: 0;\n      }\n      ', '\n      .indicator {\n        border-radius: 50%;\n        flex-shrink: 0;\n        display: flex;\n        justify-content: center;\n        align-items: center;\n        background-color: ', ';\n        width: ', ';\n        height: ', ';\n        border: ', ' solid\n          ', ';\n\n        &::before {\n          content: \'\';\n          transition: all 0.1s;\n          border-radius: 50%;\n          background-color: ', ';\n          height: calc(', ' * 0.6);\n          width: calc(', ' * 0.6);\n          border: solid ', ';\n        }\n      }\n      .description {\n        color: ', ';\n        padding-', ': 0.5rem;\n      }\n      ', '\n        ', '\n    '], ['\n      position: relative;\n      display: inline-flex;\n      margin: 0;\n      min-height: inherit;\n      padding: 0.375rem 1.5rem 0.375rem 0;\n      input {\n        position: absolute;\n        opacity: 0;\n      }\n      ', '\n      .indicator {\n        border-radius: 50%;\n        flex-shrink: 0;\n        display: flex;\n        justify-content: center;\n        align-items: center;\n        background-color: ', ';\n        width: ', ';\n        height: ', ';\n        border: ', ' solid\n          ', ';\n\n        &::before {\n          content: \'\';\n          transition: all 0.1s;\n          border-radius: 50%;\n          background-color: ', ';\n          height: calc(', ' * 0.6);\n          width: calc(', ' * 0.6);\n          border: solid ', ';\n        }\n      }\n      .description {\n        color: ', ';\n        padding-', ': 0.5rem;\n      }\n      ', '\n        ', '\n    ']),
    _templateObject3$3 = taggedTemplateLiteral(['\n          .indicator,\n          .description {\n            opacity: 0.5;\n          }\n        '], ['\n          .indicator,\n          .description {\n            opacity: 0.5;\n          }\n        ']),
    _templateObject4$3 = taggedTemplateLiteral(['\n          &:hover .indicator {\n            border-color: ', ';\n          }\n        '], ['\n          &:hover .indicator {\n            border-color: ', ';\n          }\n        ']),
    _templateObject5$2 = taggedTemplateLiteral(['\n            .indicator {\n              border-color: ', ';\n            }\n          '], ['\n            .indicator {\n              border-color: ', ';\n            }\n          ']);

var RadioStyle = styled__default.label(_templateObject$4, function (_ref) {
  var theme = _ref.theme,
      checked = _ref.checked,
      disabled = _ref.disabled,
      status = _ref.status;

  var state = checked ? 'Checked' : disabled ? 'Disabled' : '';
  var size$$1 = theme['radio' + state + 'Size'];
  return styled.css(_templateObject2$3, disabled && styled.css(_templateObject3$3), theme['radio' + state + 'Bg'], size$$1, size$$1, theme['radio' + state + 'BorderSize'], theme['radio' + state + 'BorderColor'], theme['radio' + state + 'Checkmark'], size$$1, size$$1, theme['radio' + state + 'Checkmark'], theme.radioFg, theme.dir === 'rtl' ? 'right' : 'left', !disabled && styled.css(_templateObject4$3, theme[hoverBorder$1(status)]), checked && styled.css(_templateObject5$2, theme[hoverBorder$1(status)]));
});
var hoverBorder$1 = function hoverBorder(status) {
  return status ? 'color' + status : 'radioCheckedBorderColor';
};

function Radio(props) {
  var _useState = React.useState(props.options),
      _useState2 = slicedToArray(_useState, 2),
      options = _useState2[0],
      setOptions = _useState2[1];

  var onClickHandler = function onClickHandler(value) {
    var updateOptions = [].concat(toConsumableArray(options));
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = updateOptions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var option = _step.value;

        option.checked = option.value === value;
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    setOptions(updateOptions);
    props.onChange(value);
  };

  return options.map(function (option) {
    return React__default.createElement(
      RadioStyle,
      {
        status: option.status,
        checked: option.checked,
        disabled: option.disabled || props.disabled,
        key: option.value,
        className: props.className
      },
      React__default.createElement('input', {
        type: 'radio',
        name: props.name,
        disabled: option.disabled || props.disabled,
        onClick: function onClick() {
          return onClickHandler(option.value);
        }
      }),
      React__default.createElement('span', { className: 'indicator' }),
      React__default.createElement(
        'span',
        { className: 'description' },
        option.label
      )
    );
  });
}

Radio.propTypes = {
  name: PropTypes.string,
  disabled: PropTypes.bool,
  onChange: PropTypes.func.isRequired,
  options: PropTypes.arrayOf(PropTypes.shape({
    value: PropTypes.any.isRequired,
    label: PropTypes.any.isRequired,
    checked: PropTypes.bool,
    disabled: PropTypes.bool,
    status: colorState
  }).isRequired).isRequired
};

exports.InputGroup = InputGroup;
exports.Checkbox = Checkbox;
exports.Select = Select;
exports.Radio = Radio;
